//---------------------------------------------------------------------------------------------------------
//Program Name : Main.c
//Description  : DONTSLEEP! C\[X
//---------------------------------------------------------------------------------------------------------
//History
//       1.     2007/02/03  Create
//       2.     2007/05/03  HDDANZXԊu0ȉA͖ݒ̏ꍇɖ\oOC
//                          ֐|C^̎gp@ύXi֐߂l|C^zj
//                          ̑A\[XR[hC
//       3.     2007/05/26  R\[AvP[VWindowsAvP[VɕύX
//                          JgfBNgʒuɊւ炸sł悤C
//       4.     2007/08/12  ANZXɃt@Cł͂ȂfBNg쐬悤C
//                          iANZX΍j
//       5.     2007/09/29  W֐삵ACRTNȂ悤C
//       6.     2007/11/01  gNہAnhYĂ̂C
//       7.     2013/09/21  64bitrhɑΉ
//                          INIt@CEXEt@CƓɂȂ悤ύX
//                          5.ō쐬W֐̂A\Ȃ̂Win32 APIɒuč폜
//       8.     2013/10/27  INIt@CǍs̋AvȌI牺LɕύX
//                          EANZXFǍ\ɂȂ܂őҋ@
//                          EANZXFOݒlœ
//       9.     2014/01/09  INIt@CǍ̏
//      10.     2020/06/14  vZX̎sDxuʏvuʏȉvɕύX
//                          t@C@\ǉ
//      11.     2020/06/20  t@CPʂuMBvuKBvɕύX
//                          vZX̎sDxuʏvɖ߂
//                          INIt@CǍpobt@TCY𒲐
//                          f[^̗lĂȂ̂C
//                          ľ^uunsigned longvɕύX
//                          hCu̐ݒ萔őlȏ̏ꍇAeʂ̐ݒ肪fȂoOC
//      12.     2020/06/26  ꎞt@C쐬ɁuFILE_FLAG_DELETE_ON_CLOSEvw
//      13.     2020/07/17  ꎞt@CpX̕ҏWiHDDANZX[vɃhCûݏj
//---------------------------------------------------------------------------------------------------------
//  All Rights Reserved, Copyright (c) XC 2007-2020
//---------------------------------------------------------------------------------------------------------

#include<Windows.h>
#include"mycrt.h"

// t@CpXő咷
#define MAX_LENGTH_PATH (MAX_PATH - 1) * 2
// HDDANZXԊueŏlibj
#define HDD_ACCESS_INTERVAL_MIN 1
// HDDANZXԊueőlibj
#define HDD_ACCESS_INTERVAL_MAX 999999
// HDDANZXԊulibj
#define HDD_ACCESS_INTERVAL_INIT HDD_ACCESS_INTERVAL_MIN
// eʋeŏliKBj
#define WRITE_SIZE_MIN 1
// eʋeőliKBj
#define WRITE_SIZE_MAX 1048576
// eʏliKBj
#define WRITE_SIZE_INIT 0
// őhCuihCuzvfj
#define DRIVE_NUM_MAX 26
// INIt@CǍpobt@TCY
#define BUFFER_SIZE 32
// HDDANZXpꎞfBNgpX
#define TMP_DIR_PATH "0:\\DNSLPTMP"
// HDDANZXpꎞt@CpX
#define TMP_FILE_PATH TMP_DIR_PATH "\\DNSLPTMP.TMP"
// ꎞt@Cpobt@TCY
#define W_BUFFER_SIZE 67108864
// pp[^iZpj
#define RAND_PARAM_MULTI 123457
// pp[^iZpj
#define RAND_PARAM_ADD 1249
// zZN^TCYiŏPʁj
#define SECTOR_SIZE 4096
// LoCgoCgϊ}N
#define KBToB(nKB) (nKB * 1024)

// bool^̒l
enum bool{
	false,
	true
};

// bool^
typedef int bool;

// INIt@Cf[^i[
typedef struct INIFileData {
	// HDDANZXԊu
	int nHDDAccessInterval;
	// hCuz
	char strDriveLetter[DRIVE_NUM_MAX];
	// hCuzCfbNX
	int nDriveLetterArrayIndex;
	// f[^e
	int nWriteSize;
}INIFileData;

// ANZXf[^ێ
typedef struct RegularAccessData {
	// 
	unsigned long ulRand;
}RegularAccessData;

// R}hC̗L`FbN
bool ExistCommandLineArg();
// g}EXJ[\ύXȂŋN
void ExecuteOwnNonChangeCursor(char[]);
// ݒt@CǍ
void ReadINIFile(const char[], INIFileData*);
	// HDDANZXԊuǍ
	void ReadHDDAccessInterval(const char[], INIFileData*, int*);
	// ANZXΏۃhCuǍ
	void ReadDriveLetter(const char[], INIFileData*, int*);
	// eʓǍ
	void ReadWriteSize(const char[], INIFileData*, int*);
// HDDɃANZX
void AccessHDD(INIFileData*, RegularAccessData*);
	// f[^𐶐
	unsigned long* CreateWriteData(unsigned long*, const int, RegularAccessData*);
	// ꎞt@C쐬E폜
	void CreateTempFile(const char[], const int, unsigned long*, RegularAccessData*);

// C֐
void WinMainCRTStartup() {
	// INIt@Cf[^i[
	INIFileData stINIFileData;
	// ANZXf[^ێ
	RegularAccessData stRegularAccessData;
	// EXEEINIt@CpX
	char strPath[MAX_LENGTH_PATH + 4];
	strPath[0] = '\"';

	// EXẼpX擾
	GetModuleFileName(NULL, &strPath[1], MAX_LENGTH_PATH);

	// R}hCw莞
	if (!ExistCommandLineArg()) {
		// g}EXJ[\ύXȂŋN
		ExecuteOwnNonChangeCursor(strPath);
		ExitProcess(0);
	}

	// EXẼpXINIt@C̃pX쐬
	strcpy(strrchr(strPath, '.') + 1, "INI");

	// HDDANZXԊuɏlݒ
	stINIFileData.nHDDAccessInterval = HDD_ACCESS_INTERVAL_INIT;
	// hCuzCfbNX
	stINIFileData.nDriveLetterArrayIndex = 0;
	// eʏ
	stINIFileData.nWriteSize = WRITE_SIZE_INIT;

	// f[^p̗
	stRegularAccessData.ulRand = 0;

	// ANZX[v
	while (1) {
		// ݒt@CǍ
		ReadINIFile(&strPath[1], &stINIFileData);
		// HDDɃANZX
		AccessHDD(&stINIFileData, &stRegularAccessData);
		// w莞ԕҋ@i~bj
		Sleep(stINIFileData.nHDDAccessInterval * 1000);
	}
}

// R}hC̗L`FbN
bool ExistCommandLineArg() {
	// R}hC擾
	const char* pCommandLine = GetCommandLine();
	// R}hC̍Ōォ2Ԗڂ̕p󔒂̏ꍇA
	// Ƃ݂Ȃ
	return (*(pCommandLine + strlen(pCommandLine) - 2) == ' ' ? true : false);
}

// g}EXJ[\ύXȂŋN
void ExecuteOwnNonChangeCursor(char strEXEFilePath[]) {
	// vZX
	PROCESS_INFORMATION stProcessInformation = { 0 };
	// X^[gAbv
	STARTUPINFO stStartupInfo;
	mymemset(&stStartupInfo, 0, sizeof(stStartupInfo));

	// }EXJ[\ύXȂ
	stStartupInfo.dwFlags = STARTF_FORCEOFFFEEDBACK;

	// gN
	CreateProcess(NULL, strcat(strEXEFilePath, "\" S"), NULL, NULL, FALSE, 0, NULL, NULL, &stStartupInfo, &stProcessInformation);

	// XbhEvZXnh
	CloseHandle(stProcessInformation.hThread);
	CloseHandle(stProcessInformation.hProcess);
}

// ݒt@CǍ
void ReadINIFile(const char strINIFilePath[], INIFileData* pINIFileData) {
	// t@CǍobt@
	char strBuffer[BUFFER_SIZE] = { 0 };
	// t@C|C^
	HANDLE* pFilePointer = NULL;
	// ֐|C^zCfbNX
	int nFuncPointerArrayIndex = 0;
	// ֐|C^z
	void (*pReadINIFileDataFunc[])(const char[], INIFileData*, int*) = {
		// HDDANZXԊuǍ
		ReadHDDAccessInterval,
		// ANZXΏۃhCuǍ
		ReadDriveLetter,
		// eʓǍ
		ReadWriteSize
	};

	// INIt@CJ
	if ((pFilePointer = CreateFile(strINIFilePath, GENERIC_READ, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL)) == INVALID_HANDLE_VALUE) {
		// s
		return;
	}

	// hCuzCfbNX
	pINIFileData->nDriveLetterArrayIndex = 0;
	// eʏ
	pINIFileData->nWriteSize = WRITE_SIZE_INIT;

	// INIt@C1sǂݍ
	// [܂Ń[v
	while (fgets(strBuffer, BUFFER_SIZE, pFilePointer)) {
		pReadINIFileDataFunc[nFuncPointerArrayIndex](strBuffer, pINIFileData, &nFuncPointerArrayIndex);
	}

	// INIt@C
	CloseHandle(pFilePointer);
	pFilePointer = NULL;
}

// HDDANZXԊuǍ
void ReadHDDAccessInterval(const char strBuffer[], INIFileData* pINIFileData, int* pFuncPointerArrayIndex) {
	// ǂݍ񂾃f[^𐔒lϊ
	int nReadData = atoi(strBuffer);

	// lϊAe͈͓
	if (HDD_ACCESS_INTERVAL_MIN <= nReadData && nReadData <= HDD_ACCESS_INTERVAL_MAX) {
		// HDDANZXԊuɐݒ
		pINIFileData->nHDDAccessInterval = nReadData;
		// ̃f[^̓ǍɈڂ
		(*pFuncPointerArrayIndex)++;
	}
}

// ANZXΏۃhCuǍ
void ReadDriveLetter(const char strBuffer[], INIFileData* pINIFileData, int* pFuncPointerArrayIndex) {
	// hCuKiA-Zj
	// hCui[z񂪈t̏ꍇ͊i[Ȃ
	if (0x41 <= strBuffer[0] && strBuffer[0] <= 0x5a && pINIFileData->nDriveLetterArrayIndex < DRIVE_NUM_MAX) {
		// hCuzɊi[ACfbNXCNg
		pINIFileData->strDriveLetter[pINIFileData->nDriveLetterArrayIndex++] = strBuffer[0];
	}
	// hCuǍɃZNVǂݍ񂾏ꍇ
	else if (strBuffer[0] == 0x5b && pINIFileData->nDriveLetterArrayIndex > 0) {
		// ̃f[^̓ǍɈڂ
		(*pFuncPointerArrayIndex)++;
	}
}

// eʓǍ
void ReadWriteSize(const char strBuffer[], INIFileData* pINIFileData, int* pFuncPointerArrayIndex) {
	// ǂݍ񂾃f[^𐔒lϊ
	int nReadData = atoi(strBuffer);

	// lϊAe͈͓
	if (WRITE_SIZE_MIN <= nReadData && nReadData <= WRITE_SIZE_MAX) {
		// eʂɐݒ
		pINIFileData->nWriteSize = nReadData;
	}
}

// HDDɃANZX
void AccessHDD(INIFileData* pINIFileData, RegularAccessData* pRegularAccessData) {
	int i = 0;
	// hCuzCfbNX
	int nDriveLetterArrayIndex = pINIFileData->nDriveLetterArrayIndex;
	// eʁiBytej
	int nWriteSizeByte;
	// ꎞfBNgpX
	char strTempDirPath[] = TMP_DIR_PATH;
	// ꎞt@Cobt@
	unsigned long* pWriteBuffer = NULL;
	// ꎞt@CpX
	char strTempFilePath[] = TMP_FILE_PATH;

	// eʂݒ肳Ăꍇ
	if (pINIFileData->nWriteSize > 0) {
		// eʂKBBɕϊ
		nWriteSizeByte = KBToB(pINIFileData->nWriteSize);
		// eʂZN^TCY̐{łȂꍇ
		if (nWriteSizeByte % SECTOR_SIZE) {
			// ZN^TCY̐{ɒ
			nWriteSizeByte = nWriteSizeByte / SECTOR_SIZE * SECTOR_SIZE + SECTOR_SIZE;
		}

		// ꎞt@Cobt@̃m
		pWriteBuffer = (unsigned long*)VirtualAlloc(NULL, nWriteSizeByte <= W_BUFFER_SIZE ? nWriteSizeByte : W_BUFFER_SIZE, MEM_RESERVE | MEM_COMMIT, PAGE_READWRITE);

		// ̊mۂɎsꍇAeʖݒƂĈȍ~̏s
		if (pWriteBuffer == NULL) {
			pINIFileData->nWriteSize = 0;
		}
		// eʂꎞt@Cobt@TCYȉ̏ꍇ
		else if (nWriteSizeByte <= W_BUFFER_SIZE) {
			// f[^𐶐
			CreateWriteData(pWriteBuffer, nWriteSizeByte, pRegularAccessData);
		}
	}

	// INIt@CǂݍHDD[v
	for (i = 0; i < nDriveLetterArrayIndex; i++) {
		// hCui[
		strTempDirPath[0] = pINIFileData->strDriveLetter[i];
		strTempFilePath[0] = pINIFileData->strDriveLetter[i];

		// ꎞfBNg쐬
		if (CreateDirectory(strTempDirPath, NULL) || GetLastError() == ERROR_ALREADY_EXISTS) {
			// eʂݒ肳Ăꍇ
			if (pINIFileData->nWriteSize > 0) {
				// ꎞt@C쐬E폜
				CreateTempFile(strTempFilePath, nWriteSizeByte, pWriteBuffer, pRegularAccessData);
			}

			// ꎞfBNg폜
			if (!RemoveDirectory(strTempDirPath)) {
				// sꍇAꎞt@C폜čă`W
				DeleteFile(strTempFilePath);
				RemoveDirectory(strTempDirPath);
			}
		}
	}

	// eʂݒ肳Ăꍇ
	if (pINIFileData->nWriteSize > 0) {
		// ꎞt@Cobt@̃J
		VirtualFree(pWriteBuffer, 0, MEM_RELEASE);
		pWriteBuffer = NULL;
	}
}

// ꎞt@C쐬E폜
void CreateTempFile(const char strTempFilePath[], const int nWriteSizeByte, unsigned long* pWriteBuffer, RegularAccessData* pRegularAccessData) {
	// 
	int nLoop = (nWriteSizeByte <= W_BUFFER_SIZE ? 0 : nWriteSizeByte / W_BUFFER_SIZE);
	// Ō̏TCYi[j
	int nFracSize = nWriteSizeByte - W_BUFFER_SIZE * nLoop;
	// t@C|C^
	HANDLE* pFilePointer = NULL;
	// ʃTCY
	DWORD dwWriteSize;

	// ꎞt@CJ
	// VXeLbVƃfBXNLbV𖳌
	if ((pFilePointer = CreateFile(strTempFilePath, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL | FILE_FLAG_WRITE_THROUGH | FILE_FLAG_NO_BUFFERING | FILE_FLAG_DELETE_ON_CLOSE, NULL)) == INVALID_HANDLE_VALUE) {
		// s
		return;
	}

	// eʂꎞt@Cobt@TCY傫ꍇ
	for (int i = 0; i < nLoop; i++) {
		// f[^Bsꍇ͂̎_ŏI
		if (!WriteFile(pFilePointer, CreateWriteData(pWriteBuffer, W_BUFFER_SIZE, pRegularAccessData), W_BUFFER_SIZE, &dwWriteSize, NULL)) {
			// ꎞt@C
			CloseHandle(pFilePointer);
			pFilePointer = NULL;

			return;
		}
	}

	// eʂ܂cĂꍇ
	if (nWriteSizeByte % W_BUFFER_SIZE || nWriteSizeByte == W_BUFFER_SIZE) {
		// eʂꎞt@Cobt@TCY傫ꍇ
		if (nWriteSizeByte > W_BUFFER_SIZE) {
			// f[^𐶐
			CreateWriteData(pWriteBuffer, nFracSize, pRegularAccessData);
		}
		// f[^iŌ1j
		WriteFile(pFilePointer, pWriteBuffer, nFracSize, &dwWriteSize, NULL);
	}

	// tbV
	FlushFileBuffers(pFilePointer);

	// ꎞt@CBt@C͕Ɠɍ폜
	CloseHandle(pFilePointer);
	pFilePointer = NULL;
}

// f[^𐶐
unsigned long* CreateWriteData(unsigned long* pWriteBuffer, const int nWriteSize, RegularAccessData* pRegularAccessData) {
	// 
	int nLoop = nWriteSize / sizeof(unsigned long);
	// 
	unsigned long ulRand = pRegularAccessData->ulRand;
	// VXeit@C^Cj
	FILETIME stSysDate;

	// l̏ꍇ
	if (!ulRand) {
		// VXeit@C^Cj擾
		GetSystemTimeAsFileTime(&stSysDate);
		// VXeit@C^Cj̉32bit𗐐̃V[hɐݒ
		ulRand = stSysDate.dwLowDateTime;
	}

	// Ȉ՗𐶐ďf[^Ƃ
	for (int i = 0; i < nLoop; i++) {
		ulRand *= RAND_PARAM_MULTI;
		ulRand += RAND_PARAM_ADD;

		pWriteBuffer[i] = ulRand;
	}

	// ێ
	pRegularAccessData->ulRand = ulRand;

	return pWriteBuffer;
}
